#ifndef __OBJECTPVS_H
#define __OBJECTPVS_H

#include "common.h"
#include "PvsDefinitions.h"

using namespace std;

namespace GtpVisibilityPreprocessor {

class KdNode;
class BspNode;
class Ray;
class Intersectable;
class ViewCell;


class ObjectPvs: public DefaultPvs
{
public:
	/** Counts object int the pvs. Different to method "GetSize", not
		only the raw container size is returned,
		but the individual contributions of the entries are summed up.
	*/
	float EvalPvsCost() const;

	friend ostream &operator<<(ostream &s, const ObjectPvs &p) 
	{
		ObjectPvsIterator pit = p.GetIterator();

		while (pit.HasMoreEntries())
		{		
			const ObjectPvsEntry &entry = pit.Next();
			Intersectable *obj = entry.mObject;

			cout << obj << " ";
		}
		
		return s;
	}
};



}

#endif

